From 9f6c075e3ccadb38ed73b416c8eaf1122e16afde Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 08 2020 05:31:03 +0000
Subject: [PATCH 865/2232] Inline cxx-symbols crate into cxx


The separation is no longer needed for Buck when linking with lld.

---

diff --git a/BUCK b/BUCK
index 5f2a65f..695c079 100644
--- a/BUCK
+++ b/BUCK
@@ -1,11 +1,10 @@
 rust_library(
     name = "cxx",
-    srcs = glob(["src/**"], exclude = ["src/symbols/**"]),
+    srcs = glob(["src/**"]),
     visibility = ["PUBLIC"],
     deps = [
         ":core",
         ":macro",
-        ":symbols",
     ],
 )
 
@@ -32,12 +31,6 @@ cxx_library(
         "cxx.h": "include/cxx.h",
     },
     exported_linker_flags = ["-lstdc++"],
-    deps = [":symbols"],
-)
-
-rust_library(
-    name = "symbols",
-    srcs = glob(["src/symbols/**"]),
 )
 
 rust_library(
diff --git a/BUILD b/BUILD
index 197cef2..27c6931 100644
--- a/BUILD
+++ b/BUILD
@@ -2,18 +2,12 @@ load("//tools/bazel:rust.bzl", "rust_binary", "rust_library")
 
 rust_library(
     name = "cxx",
-    srcs = glob(
-        ["src/**/*.rs"],
-        exclude = ["src/symbols/**/*.rs"],
-    ),
+    srcs = glob(["src/**/*.rs"]),
     proc_macro_deps = [
         ":cxxbridge-macro",
     ],
     visibility = ["//visibility:public"],
-    deps = [
-        ":core-lib",
-        ":symbols",
-    ],
+    deps = [":core-lib"],
 )
 
 rust_binary(
@@ -45,11 +39,6 @@ cc_library(
 )
 
 rust_library(
-    name = "symbols",
-    srcs = glob(["src/symbols/**/*.rs"]),
-)
-
-rust_library(
     name = "cxxbridge-macro",
     srcs = glob(["macro/src/**"]),
     crate_type = "proc-macro",
diff --git a/Cargo.toml b/Cargo.toml
index a2aaf8a..73539f7 100644
--- a/Cargo.toml
+++ b/Cargo.toml
@@ -20,7 +20,6 @@ default = ["cxxbridge-flags/default"] # c++11
 "c++20" = ["cxxbridge-flags/c++20"]
 
 [dependencies]
-cxx-symbols = { version = "=0.4.3", path = "src/symbols" }
 cxxbridge-macro = { version = "=0.4.3", path = "macro" }
 link-cplusplus = "1.0"
 
@@ -35,7 +34,7 @@ rustversion = "1.0"
 trybuild = { version = "1.0.33", features = ["diff"] }
 
 [workspace]
-members = ["demo", "flags", "gen/build", "gen/cmd", "gen/lib", "macro", "src/symbols", "tests/ffi"]
+members = ["demo", "flags", "gen/build", "gen/cmd", "gen/lib", "macro", "tests/ffi"]
 
 [package.metadata.docs.rs]
 targets = ["x86_64-unknown-linux-gnu"]
diff --git a/src/lib.rs b/src/lib.rs
index 8c7344b..b0fe00d 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -369,8 +369,9 @@
 
 #[cfg(built_with_cargo)]
 extern crate link_cplusplus;
+
 #[macro_use]
-extern crate symbols;
+mod macros;
 
 mod cxx_string;
 mod cxx_vector;
@@ -383,6 +384,7 @@ mod rust_sliceu8;
 mod rust_str;
 mod rust_string;
 mod rust_vec;
+mod symbols;
 mod unique_ptr;
 mod unwind;
 
diff --git a/src/macros/assert.rs b/src/macros/assert.rs
new file mode 100644
index 0000000..5d5ea9e
--- /dev/null
+++ b/src/macros/assert.rs
@@ -0,0 +1,7 @@
+#[macro_export]
+#[doc(hidden)]
+macro_rules! const_assert_eq {
+    ($left:expr, $right:expr $(,)?) => {
+        const _: [(); $left] = [(); $right];
+    };
+}
diff --git a/src/macros/concat.rs b/src/macros/concat.rs
new file mode 100644
index 0000000..5ee77c5
--- /dev/null
+++ b/src/macros/concat.rs
@@ -0,0 +1,8 @@
+#[macro_export]
+#[doc(hidden)]
+macro_rules! attr {
+    (#[$name:ident = $value:expr] $($rest:tt)*) => {
+        #[$name = $value]
+        $($rest)*
+    };
+}
diff --git a/src/macros/mod.rs b/src/macros/mod.rs
new file mode 100644
index 0000000..d12d96b
--- /dev/null
+++ b/src/macros/mod.rs
@@ -0,0 +1,4 @@
+#[macro_use]
+mod assert;
+#[macro_use]
+mod concat;
diff --git a/src/rust_vec.rs b/src/rust_vec.rs
index 5e7082a..6f1d567 100644
--- a/src/rust_vec.rs
+++ b/src/rust_vec.rs
@@ -3,7 +3,7 @@ use std::mem::ManuallyDrop;
 
 #[repr(C)]
 pub struct RustVec<T> {
-    repr: Vec<T>,
+    pub(crate) repr: Vec<T>,
 }
 
 impl<T> RustVec<T> {
diff --git a/src/symbols/mod.rs b/src/symbols/mod.rs
new file mode 100644
index 0000000..a9d158d
--- /dev/null
+++ b/src/symbols/mod.rs
@@ -0,0 +1,4 @@
+mod exception;
+mod rust_str;
+mod rust_string;
+mod rust_vec;
diff --git a/src/symbols/rust_string.rs b/src/symbols/rust_string.rs
index 94b2110..5c2982d 100644
--- a/src/symbols/rust_string.rs
+++ b/src/symbols/rust_string.rs
@@ -3,11 +3,6 @@ use std::ptr;
 use std::slice;
 use std::str;
 
-#[repr(C)]
-pub(crate) struct RustString {
-    repr: String,
-}
-
 #[export_name = "cxxbridge04$string$new"]
 unsafe extern "C" fn string_new(this: &mut MaybeUninit<String>) {
     ptr::write(this.as_mut_ptr(), String::new());
diff --git a/src/symbols/rust_vec.rs b/src/symbols/rust_vec.rs
index 7789454..fb49b40 100644
--- a/src/symbols/rust_vec.rs
+++ b/src/symbols/rust_vec.rs
@@ -1,12 +1,8 @@
 use crate::rust_string::RustString;
+use crate::rust_vec::RustVec;
 use std::mem;
 use std::ptr;
 
-#[repr(C)]
-pub(crate) struct RustVec<T> {
-    repr: Vec<T>,
-}
-
 macro_rules! rust_vec_shims {
     ($segment:expr, $ty:ty) => {
         const_assert_eq!(mem::size_of::<[usize; 3]>(), mem::size_of::<Vec<$ty>>());
